import java.util.*;


class DistanceMatrix 
{
	Vector<SimTreeLeaf> nodes;

	int distance[][];

	DistanceMatrix() 
	{
		nodes = new Vector<SimTreeLeaf>();
		distance = null;
	}

	void fillList(SimTreeLeaf n) 
	{
		n.DistanceMatrixIndex=nodes.size();
		nodes.add(n);
		for (int i = 0; i < n.children.length; i++) {
			fillList(n.children[i]);
		}
	}

	void calculateDistances() 
	{
		distance = new int[nodes.size()][nodes.size()];
		for (int i = 0; i < nodes.size(); i++) {
			for (int j = 0; j <= i; j++) {
				int childij, childji;
				childij = ((SimTreeLeaf) nodes.get(i)).childlevel(
						(SimTreeLeaf) nodes.get(j));
				childji =((SimTreeLeaf) nodes.get(j)).childlevel(
						(SimTreeLeaf) nodes.get(i));
				if (i == j)
					distance[i][j] = 0;
				else if (childij >= 0)
					distance[i][j] = childij;
				else if (childji >= 0)
					distance[i][j] = childji;
				else {
					int nparent = 0;
					SimTreeLeaf par = (SimTreeLeaf) nodes.get(i);
					while (par.childlevel((SimTreeLeaf) nodes.get(j)) < 0) {
						par = par.parent;
						nparent++;
					}
					distance[i][j] = par.childlevel((SimTreeLeaf) nodes.get(j))
							+ nparent;
				}
				distance[j][i] = distance[i][j] = distance[i][j]
						+ SimKernel.BStransmissionCost;
			}
		}
	}


	int getDistance(SimTreeLeaf s,SimTreeLeaf t)
	{
		return distance[s.DistanceMatrixIndex][t.DistanceMatrixIndex];
	}
}