import java.awt.*;
import java.awt.image.*;


class ImageLoader
{
	static BufferedImage loadImage(String fname, double scale)
	{
	    // load image from INFILE
	    Image image = Toolkit.getDefaultToolkit().getImage(fname);
	    MediaTracker mediaTracker = new MediaTracker(new Container());
	    mediaTracker.addImage(image, 0);
	    try{
	    mediaTracker.waitForID(0);
	    }catch(InterruptedException e)
	    {
	    	return null;
	    }
	    // determine thumbnail size from WIDTH and HEIGHT
	    int imageWidth = image.getWidth(null);
	    int imageHeight = image.getHeight(null);
	    int thumbWidth = (int)(imageWidth*scale);
	    int thumbHeight = (int)(imageHeight*scale);
	    // draw original image to thumbnail image object and
	    // scale it to the new size on-the-fly
	    BufferedImage thumbImage = new BufferedImage(thumbWidth, 
	      thumbHeight, BufferedImage.TYPE_INT_ARGB);
	    Graphics2D graphics2D = thumbImage.createGraphics();
	    graphics2D.setRenderingHint(RenderingHints.KEY_INTERPOLATION,
	      RenderingHints.VALUE_INTERPOLATION_BILINEAR);
	    graphics2D.drawImage(image, 0, 0, thumbWidth, thumbHeight, null);
	    return thumbImage;
	}
}