import java.util.*;

class SimDataPacket
{
	static int packetId=0;
	SimTreeLeaf initiator;
	long startTime;
	long deliveryTime;
	int nHops;
	int id;
	SimDataPacket(SimTreeLeaf initiator, long startTime)
	{
		this.initiator=initiator;
		this.startTime=startTime;
		nHops=0;
		id=packetId++;
		SimKernel.theKernel.stats.allPackages.add(this); // i know this is long but it is better this way
	}
}

class MessageQueue
{
	ArrayList<SimDataPacket> buffer; // the messages are forwarded according to their initiation time in this array
	
	Vector<SimDataPacket> incoming;
	
	public MessageQueue()
	{
		buffer=new ArrayList<SimDataPacket>();
		incoming=new Vector<SimDataPacket>();
	}
	
	void reset()
	{
		buffer.clear();
		incoming.clear();
	}
	
	void recvMessages() // receive all pkgs in buffer
	{
		for (int i=0;i<incoming.size();i++)
		{
			int s=0,e=buffer.size()-1;
			do
			{
				if (s>=e)
				{
					buffer.add(s, incoming.get(i));
					break;
				}
				else if (incoming.get(i).startTime > buffer.get(e).startTime)
				{
					buffer.add(e+1, incoming.get(i));
					break;
				}
				else if (incoming.get(i).startTime < buffer.get(s).startTime)
				{
					buffer.add(s,incoming.get(i));
					break;
				}
				if (e-s==1)
				{
					if (incoming.get(i).startTime < buffer.get(s).startTime)
						buffer.add(s,incoming.get(i));
					else if (incoming.get(i).startTime < buffer.get(e).startTime)
						buffer.add(e,incoming.get(i));
					else
						buffer.add(e+1,incoming.get(i));
					break;
				}
				if (incoming.get(i).startTime < buffer.get((s+e)/2).startTime)
					e=(s+e)/2;
				else
					s=(s+e)/2;
			}while(s<=e);
		}
		incoming.clear();
	}
	
	void transferMessages(MessageQueue target, int count)
	{
		for (int i=0;i<count;i++)
			target.incoming.add(buffer.remove(0));
	}
	
	void sendToBS(int count)
	{
		for (int i=0;i<count;i++)
		{
			SimDataPacket pkg=buffer.remove(0); // we remove count packages from buffer 
			pkg.deliveryTime=SimKernel.theKernel.currentTime;
		}
	}
}
