import java.awt.geom.*;

class Salmon 
{
	Point2D.Double pos; // position (in pixels)

	static double v = 50;

	static boolean useMerchant = false;
	static boolean useMerchantv2 = false;
	static boolean useMerchantv3 = false;
	static boolean useRandomWalker =false;
	static boolean useSimpleFisher = false;
	static boolean useTSPFisher = false;
	static boolean useMLPFisher = false;
	
	static int treeTourLength;

	SimKernel krn;

	SimTreeLeaf currentNode;

	SimTreeLeaf targetNode;
	
	SimController controller;
	
	int collectedPackages;

	Salmon(SimKernel krn) 
	{
		this.krn = krn;
		pos=new Point2D.Double();
		if (useMerchant)
			controller=new TotalBufferSizeController();
		else if (useMerchantv2)
			controller=new MaxBufferSizeController();
		else if (useMerchantv3)
			controller=new WeightedBufferSizeController();
		else if (useRandomWalker)
			controller=new RandomWalkController();
		else if (useSimpleFisher)
			controller=new SimpleFisherController(); 
		else if (useTSPFisher)
			controller=new TSPFisherController();
		else if (useMLPFisher)
			controller=new MLPFisherController();
		else
			controller=new IdealSalmonController();
		//controller=new AStarController();
		reset();
	}

	void reset() 
	{
		currentNode = krn.treeRoots.get(0).root;////WARNING
		targetNode = krn.treeRoots.get(0).root;////WARNING
		pos.x = currentNode.pos.x;
		pos.y = currentNode.pos.y;
		collectedPackages=0;
		controller.reset();
	}

	void step(double t) 
	{
		double dist = pos.distance(targetNode.pos);
		if (dist < v * t) 
		{
			pos.x = targetNode.pos.x;
			pos.y = targetNode.pos.y;
			currentNode = targetNode;
		} else 
		{
			pos.x = pos.x + (targetNode.pos.x - pos.x) / dist * v * t;
			pos.y = pos.y + (targetNode.pos.y - pos.y) / dist * v * t;
		}
		if (currentNode == targetNode) 
		{
			targetNode=controller.getNext(currentNode);
		}
		// System.out.println("stepping mbs: "+t+" ("+x+","+y+")" );
	}
	
}