import java.awt.*;
import java.awt.image.*;
import java.awt.geom.*;
import javax.swing.*;

class SimPanel extends JPanel 
{
	/**
	 * 
	 */
	private static final long serialVersionUID = -7514782229906817357L;
	BufferedImage salmonImage;
	Image img;
	Graphics g;
	AnimCreator anim;
	SimPanel()
	{
		salmonImage=ImageLoader.loadImage("salmon.png", 0.3);
		img=null;
		anim=null;
	}
	
	public void paint(Graphics graph) {
		if (img==null)
		{
			img=createImage(this.getWidth(),this.getHeight());
			g=img.getGraphics();
			anim=new AnimCreator(this.getWidth(),this.getHeight());
		}
		g.clearRect(0,0,this.getWidth(),this.getHeight());
		// just place all event data on the display with circles
		SimKernel krn = SimKernel.theKernel;

		for (int i=0;i<krn.treeRoots.size();i++)
		{
			paintTree(g, krn.treeRoots.get(i).root);
			String str=""+((char)('A'+i));
			g.setColor(Color.black);
			g.drawString(str, (int)krn.treeRoots.get(i).root.pos.x+15, (int)krn.treeRoots.get(i).root.pos.y+15);
		}
		paintRobot(g, krn.theFish);
		graph.drawImage(img, 0, 0,null);
		if (SimKernel.saveImages && salmonSim.sd.ticker.running)
		{
			anim.saveImage(img, "solmonAnim", salmonSim.sd.ticker.cframe);
		}
	}

	void paintTree(Graphics g, SimTreeLeaf node) 
	{
		int x = (int) node.pos.x;
		int y = (int) node.pos.y;
		for (int i = 0; i < node.children.length; i++) 
		{
			int cx, cy;
			cx = (int) node.children[i].pos.x;
			cy = (int) node.children[i].pos.y;
			int level=node.children[i].level;
			if (node.children[i].arrowNext==node)
			{
				g.setColor(Color.black);
				drawArrow(g, cx, cy, x, y,node.pos.distance(node.children[i].pos)-(10 - level / 2));
			}
			else
			{
				g.setColor(Color.red);
				drawArrow(g, x, y, cx, cy,node.pos.distance(node.children[i].pos)-(10 - level / 2));
			}
			
/*			g.setColor(Color.magenta);
			String str=""+node.children[i].downStreamBufferSize;
			FontMetrics f=g.getFontMetrics();
			Rectangle2D r=f.getStringBounds(str, g);
			
			g.drawString(str, (int)((x+cx)/2-r.getCenterX()), (int)((y+cy)/2-r.getCenterY()));*/
		}
		for (int i = 0; i < node.children.length; i++) 
		{
			paintTree(g, node.children[i]);
		}
		int level = node.level;
		Color col=new Color(node.state,1-node.state,0);
		if (node.state>0)
			g.setColor(Color.gray);
		else
			g.setColor(Color.black);
		g.fillOval(x - 10 + level / 2, y - 10 + level / 2, 20 - level,
				20 - level);
		g.drawOval(x - 10 + level / 2, y - 10 + level / 2, 20 - level,
				20 - level);
		g.setColor(Color.yellow);
		String str=""+node.bufferSize;
		FontMetrics f=g.getFontMetrics();
		Rectangle2D r=f.getStringBounds(str, g);
		
		g.drawString(str, (int)(x-r.getCenterX()), (int)(y-r.getCenterY()));
	}
	
	public void update(Graphics g)
	{
		paint(g); 
	}


	void paintRobot(Graphics g, Salmon fish) {
		/*
		g.setColor(Color.yellow);
		g.fillRect((int) (fish.x - 10), (int) fish.y - 10, 20, 20);
		g.setColor(Color.black);
		g.drawRect((int) fish.x - 10, (int) fish.y - 10, 20, 20);*/
		g.setColor(Color.cyan);
		drawArrow(g,(int)fish.pos.x, (int)fish.pos.y, (int)fish.targetNode.pos.x, (int)fish.targetNode.pos.y,10000);
		g.drawImage(salmonImage,(int)fish.pos.x-salmonImage.getWidth()/2,(int)fish.pos.y-salmonImage.getHeight()/2,null);
	}
	
	void drawArrow(Graphics g, int x1,int y1,int x2, int y2,double maxlen)
	{
		final int caplength=10;
		double len=Math.sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1));
		double theta=Math.atan2(y2-y1,x2-x1);
		double theta1=theta-Math.PI+Math.PI/6;
		double theta2=theta-Math.PI-Math.PI/6;
		if (len>maxlen)
			len=maxlen;
		x2=(int)( x1+Math.cos(theta)*len);
		y2=(int)(y1+Math.sin(theta)*len);
		g.drawLine(x1, y1,x2,y2);
		g.drawLine(x2,y2,(int)(x2+Math.cos(theta1)*caplength),(int)(y2+Math.sin(theta1)*caplength));
		g.drawLine(x2,y2,(int)(x2+Math.cos(theta2)*caplength),(int)(y2+Math.sin(theta2)*caplength));		
	}
}